=== debian/control ===
Source: ros-noetic-sick-scan
Section: misc
Priority: optional
Maintainer: Michael Lehning <michael.lehning@lehning.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-message-generation, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-tf2, ros-noetic-visualization-msgs
Homepage: http://wiki.ros.org/sick_scan
Standards-Version: 3.9.2

Package: ros-noetic-sick-scan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-message-runtime, ros-noetic-pcl-conversions, ros-noetic-pcl-ros, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-tf2, ros-noetic-visualization-msgs
Description: A ROS driver for the SICK TiM and SICK MRS series of lidars.
 This package is based on the original sick_tim-repository of Martin Günther et al.
